﻿var express = require('express');
var router = express.Router();
var Connection = require('tedious').Connection;
var Request = require('tedious').Request;
var passport = require('passport');
var LocalStrategy = require('passport-local').Strategy;
var GoogleStrategy = require('passport-google').Strategy;

passport.use(new GoogleStrategy({
    returnURL: 'http://localhost:1234/login/google/return',
    realm: 'http://localhost:1234/'
},
  function (identifier, done) {
      User.findByOpenID({ openId: identifier }, function (err, user) {
          return done(err, user);
      });
  }
));
passport.use(new LocalStrategy(
  function (username, password, done) {
      User.findOne({ username: username }, function (err, user) {
          if (err) { return done(err); }
          if (!user) { return done(null, false); }
          if (!user.verifyPassword(password)) { return done(null, false); }
          return done(null, user);
      });
  }
));

// routes
router.get('/login', function (req, res) {

    res.render('login');

});

router.post('/login/local', passport.authenticate('local',
  function (req, res) {

      var sLogin = req.body.txtLogin;
      var sPassword = req.body.txtPassword;
      passport.use(new LocalStrategy(({
          usernameField: 'username',
          passwordField: 'password'
      },
        function (sLogin, sPassword, done) {
            findByUsername(sLogin);
        })
      ));


      res.redirect('/survey');
  }));


router.get('/login/google', passport.authenticate('google', { failureRedirect: '/login' }),
  function (req, res) {
      res.redirect('/survey');
  });

router.get('/login/google/return',
  passport.authenticate('google', { failureRedirect: '/login' }),
  function (req, res) {
      res.redirect('/survey');
  });

passport.serializeUser(function (user, done) {
    done(null, user.id);
});

passport.deserializeUser(function (id, done) {
    User.findById(id, function (err, user) {
        done(err, user);
    });
});


module.exports = router;
