﻿"use strict";
var express = require('express');
var path = require('path');
var bodyParser = require('body-parser');
var busboy = require('connect-busboy');
var cache = require('memory-cache');
var fs = require('fs');
var passport = require('passport');
var socketio = require('socket.io');
var http = require('http');

var server = express();
var Connection = require('tedious').Connection;
var Request = require('tedious').Request;
server.use(passport.initialize());


// config
server.set('view engine', 'ejs');
server.set('views', path.join(__dirname, 'views'));

// server files directly to the browser such as css, js, images etc
server.use(busboy());
server.use(bodyParser.urlencoded({ extended: true }));
server.use(express.static(__dirname)); // css

server.use(require('./details'));
server.use(require('./survey'));
server.use(require('./playerAdmin'));
server.use(require('./login'));
server.route('/upload')
    .post(function (req, res, next) {

        req.pipe(req.busboy);
        req.busboy.on('file', function (fieldName, oFile, fileName) {
            console.log("Uploading: " + fileName);

            //Path where image will be uploaded
            var fStream = fs.createWriteStream(__dirname + '/images/' + fileName);
            oFile.pipe(fStream);
            fStream.on('close', function () {
                console.log("Upload Finished of " + fileName);
                res.redirect('back');           //where to go next
            });
        });
    });


function Person() {
    this.id = 0;
    this.lastName = "";
    this.firstName = "";

}
function Player() {
    this.protoype = Person;
    this.sport = "";
    this.displayName = function () {
        return (this.lastName + ',' + this.firstName);
    }
}

function fetchPlayers() {
    try {
        var arrPlayers = [];

        var config = {
            userName: 'username',
            password: 'password',
            server: '12.345.678.90',
            options:
        {
            database: "Test"
        }

        };

        var connection = new Connection(config);
        connection.on('connect', function (err) {
            var request = new Request("select * from tblPlayers", function (err, rowCount) {
                if (err) {
                    console.log(err);
                } else {
                    console.log(arrPlayers.length);
                }

                connection.close();
            });

            request.on('row', function (columns) {
                var oPlayer = new Player();
                columns.forEach(function (column) {
                    if (column.value === null) {
                        console.log('NULL');
                    } else {

                        // console.log(column.metadata.colName);
                        switch (column.metadata.colName) {

                            case "firstName":
                                oPlayer.firstName = column.value;
                                break;
                            case "lastName":
                                oPlayer.lastName = column.value;
                                break;
                            case "sport":
                                oPlayer.sport = column.value;
                                break;
                            case "id":
                                oPlayer.id = column.value;
                                break;
                        }
                    }

                }); // columns for each

                arrPlayers.push(oPlayer);
            }); // rows for each
        
            cache.put("PlayerList", arrPlayers);

            request.on('done', function (rowCount, more) {

            });

            connection.execSql(request);

        }); // connection on
    }
    catch (Error) {
        console.log(Error);
    }
}

server.listen(1234, function () {
    fetchPlayers();
});
