﻿"use strict";
var express = require('express');
var router = express.Router();
var Connection = require('tedious').Connection;
var Request = require('tedious').Request;
var cache = require('memory-cache');

function Person() {
    this.id = 0;
    this.lastName = "";
    this.firstName = "";

}
function Player() {
    this.protoype = Person;
    this.sport = "";
    this.displayName = function () {
        return (this.lastName + ',' + this.firstName);
    }
}

router.post('/playerAdmin', function (req, res) {

    var config = {
        userName: 'username',
        password: 'password',
        server: '12.345.678.90',
        options:
    {
        database: "Test"
    }

    };

    var connection = new Connection(config);

    connection.on('connect', function (err) {

        var TYPES = require('tedious').TYPES;

        var sql = 'insert into tblPlayers (id, firstName, lastName, sport)';
        sql += 'values (@id, @first, @last, @sport)';

        var request = new Request(sql, function (err) {
        });

        var sFirst = req.body.txtFirst;
        var sLast = req.body.txtLast;
        var sSport = req.body.txtSport;
        var iID = req.body.txtID;

        request.addParameter('id', TYPES.Int, iID);
        request.addParameter('first', TYPES.VarChar, sFirst);
        request.addParameter('last', TYPES.VarChar, sLast);
        request.addParameter('sport', TYPES.VarChar, sSport);

        connection.execSql(request);
        fetchPlayers(res);

    }); // connection on

    connection.on('debug', function (text) {
        console.log(text);
    });

    
});

router.get('/playerAdmin', function (req, res) {
    res.render('playerAdmin');
});



function fetchPlayers(res) {
    try {
        var arrPlayers = [];

        var config = {
            userName: 'username',
            password: 'password',
            server: '12.345.678.90',
            options:
        {
            database: "Test"
        }

        };

        var connection = new Connection(config);
        connection.on('connect', function (err)
        {
            var request = new Request("select * from tblPlayers", function (err, rowCount) {
                if (err) {
                    console.log(err);
                } else {

                    res.redirect('/survey');
                    res.render('survey', {

                        players: cache.get("PlayerList")

                    });
                }

                connection.close();
           });

            request.on('row', function (columns)
            {
                var oPlayer = new Player();
                columns.forEach(function (column)
                {
                    if (column.value === null) {
                        console.log('NULL');
                    } else {

                        // console.log(column.metadata.colName);
                        switch (column.metadata.colName) {

                            case "firstName":
                                oPlayer.firstName = column.value;
                                break;
                            case "lastName":
                                oPlayer.lastName = column.value;
                                break;
                            case "sport":
                                oPlayer.sport = column.value;
                                break;
                            case "id":
                                oPlayer.id = column.value;
                                break;
                        }
                    }

                });// columns for each

                arrPlayers.push(oPlayer);
                cache.put("PlayerList", arrPlayers);
            }); // rows for each

            request.on('done', function (rowCount, more) {

            });

            connection.execSql(request);
           
        }); // connection on
    }
    catch (Error) {
        alert(Error);
    }
}

module.exports = router;